package mvc;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class View extends JPanel implements ListSelectionListener {
	
    private JList listView;
    
    private DefaultListModel listModel;
    
    private static final String ajoutString = "Ajouter";
    private static final String retirerString = "Supprimer";
    private JButton retirerButton;
    private JTextField fruitName;

    public View() {
        super(new BorderLayout());
        listModel = new Model();

////////////////////////////////////////////////////////////////
        //Association entre vue et modèle
        listView = new JList(listModel);
        
        listView.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        listView.setSelectedIndex(0);
        listView.addListSelectionListener(this);
        listView.setVisibleRowCount(5);
        JScrollPane listScrollPane = new JScrollPane(listView);
        fruitName = new JTextField(10);
        

        //////////////////////////////////////////////////////////////////
        //Création des contrôleurs
 
        JButton hireButton = new JButton(ajoutString);
        AddControler hireListener = new AddControler(hireButton,fruitName,listModel,listView);
        hireButton.setActionCommand(ajoutString);
        hireButton.addActionListener(hireListener);
        hireButton.setEnabled(false);

        /////////////////////////////////////// JTextField est aussi construit en MVC
        fruitName.addActionListener(hireListener);
        fruitName.getDocument().addDocumentListener(hireListener);
        String name = listModel.getElementAt(listView.getSelectedIndex()).toString();
        
        retirerButton = new JButton(retirerString);
        retirerButton.setActionCommand(retirerString);
        retirerButton.addActionListener(new RemoveControler(listModel,listView));

        //Create a panel that uses BoxLayout.
        JPanel buttonPane = new JPanel();
        buttonPane.setLayout(new BoxLayout(buttonPane,BoxLayout.LINE_AXIS));
        buttonPane.add(retirerButton);
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(new JSeparator(SwingConstants.VERTICAL));
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(fruitName);
        buttonPane.add(hireButton);
        buttonPane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

        add(listScrollPane, BorderLayout.CENTER);
        add(buttonPane, BorderLayout.PAGE_END);
    }

    
    
    

    //This listener is shared by the text field and the hire button.
 
    //This method is required by ListSelectionListener.
    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting() == false) {

            if (listView.getSelectedIndex() == -1) {
            //No selection, disable fire button.
                retirerButton.setEnabled(false);

            } else {
            //Selection, enable the fire button.
                retirerButton.setEnabled(true);
            }
        }
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("MVC Demo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        JComponent newContentPane = new View();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
